<?php
/**
 * @file
 *   Defines main menu callback for the JStats module, and some utility
 *   functions.
 */

/**
 * Writes access record in jstats_accesslog.
 *
 * @param $return boolean
 *   If TRUE, the inserted record will be returned to the calling code.
 *   If FALSE, the json representation of the record will be printed.
 *   Defaults to FALSE.
 */
function jstats_callback($return = FALSE) {
  global $user;

  // Get the most reliable uid we can have without
  // further bootstraping Drupal.
  if (!empty($user) && is_object($user)) {
    $uid = $user->uid;
  }
  elseif (isset($_COOKIE['DRUPAL_UID'])) {
    $uid = $_COOKIE['DRUPAL_UID'];
  }
  else {
    $uid = 0;
  }

  // Retrieve the nid from the POST value if there's one
  $nid = isset($_POST['nid']) ? $_POST['nid'] : 0;

  $record = new stdClass();
  $record->path = $_POST['path'];
  $record->nid = $nid;
  $record->uid = $uid;
  $record->timestamp = time();

  db_query("INSERT INTO {jstats_accesslog}(path, nid, uid, timestamp) VALUES('%s', %d, %d, %d)", array($record->path, $record->nid, $record->uid, $record->timestamp));
  $record->aid = db_last_insert_id('jstats_accesslog', 'aid');

  if ($return) {
    return $record;
  }
  else {
    drupal_json($record);
  }
}
